<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FotoTarefaGerChkService;
use FM\Traits\TResponse;

class FotoTarefaGerChkController extends FMCrud{
    
    use TResponse;
    
    protected $FotoTarefaGerChkService;
   
    public function __construct($crudService, $environment, FotoTarefaGerChkService $FotoTarefaGerChkService) {
        parent::__construct($crudService, $environment);
        $this->FotoTarefaGerChkService = $FotoTarefaGerChkService;
    }
   
    public function anexarFoto(DTO\Request $request, DTO\Response $response){
        try {
            $this->FotoTarefaGerChkService->anexarFoto($request->getParameters());
            $this->sendResponse('success', 201);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
       
    public function getFoto(DTO\Request $request, DTO\Response $response){
        try {
            $fotos = $this->FotoTarefaGerChkService->getFoto($request->getParameters());
            $this->sendResponse($fotos, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
       
    public function deleteFoto(DTO\Request $request, DTO\Response $response){
        try {
            $this->FotoTarefaGerChkService->deleteFoto($request->getParameters());
            $this->sendResponse('success', 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>