/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GRSV                                                     */
/* Tabela : GRUPSERV                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 02/08/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_GRSV
BEFORE INSERT OR UPDATE OR DELETE
ON GRUPSERV FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUGRSV := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUGRSV := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('GRUPSERV', '', 'CDGRUPSERV='||:OLD.CDGRUPSERV||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE GRUPSERV MODIFY DTULTATUGRSV DEFAULT SYSDATE
/
