/* Sistemas Integrados TECNISA
   Gesto de Projetos

Nome: 8803_GEPSTPO.sql

Descrio:
Insero da descrio de uma nova evoluo de requisito no momento da reprovao da
mesma a partir da descrio da evoluo candidata do requisito.

Criao:
25/08/2004 Tlio
*/

CREATE OR REPLACE PROCEDURE INSERE_DESCREQPROD_REPROVADA
  (P_CDPRODGRUP       IN VARCHAR2,
   P_CDREQPROD        IN VARCHAR2,
   P_NRSEQREQPROD     IN VARCHAR2) IS
BEGIN
   FOR C_CURSOR IN 
   (SELECT
       P_CDPRODGRUP,
       P_CDREQPROD,
       P_NRSEQREQPROD,
       DES.NRDSREQPROD,
       DES.TXREQPROD
    FROM
       DESCREQPROD DES,
       EVOLREQPROD EVO
    WHERE
      DES.CDPRODGRUP   = P_CDPRODGRUP     AND
      DES.CDREQPROD    = P_CDREQPROD      AND
      EVO.CDPRODGRUP   = DES.CDPRODGRUP   AND
      EVO.CDREQPROD    = DES.CDREQPROD    AND
      EVO.NRSEQREQPROD = DES.NRSEQREQPROD AND
      EVO.IDSTEVORPROD = 'C') LOOP
    INSERT INTO DESCREQPROD
      (CDPRODGRUP,
       CDREQPROD,
       NRSEQREQPROD,
       NRDSREQPROD,
       TXREQPROD)
    VALUES
       (C_CURSOR.P_CDPRODGRUP,
        C_CURSOR.P_CDREQPROD,
        C_CURSOR.P_NRSEQREQPROD,
        C_CURSOR.NRDSREQPROD,
        C_CURSOR.TXREQPROD);
    END LOOP; 
END;
/
